GRML2USB(8)

NAME
grml2usb - install Grml ISO(s) on USB device for booting

SYNOPSIS

grml2usb [ options ] <ISO[s]> <device>

Important! The Grml team does not take responsibility for loss of any data!

INTRODUCTION

grml2usb installs Grml on a given partition of your USB device and makes it bootable. It provides multiboot ISO support, meaning you can specify several Grml ISOs on the command line at once and select the Grml flavour you would like to boot on the bootprompt then. Note that the first ISO specified on the grml2usb command line will become the default one (that’s the one that will boot when just pressing enter on the bootprompt or wait until the boot timeout matches).

    Important

    By default a compatible master boot record (MBR) is installed on the device (being for example /dev/sdX when executing grml2usb grml.iso /dev/sdX1) and syslinux is being used as default bootloader. Avoid installation of the default MBR using the --skip-mbr option or if you encounter any problems with the default MBR consider using --syslinux-mbr instead.

OPTIONS

ISO[s] should be the path to one or multiple grml-ISOs and/or the path to the currently running live-system (being /run/live/medium).

The device either might be a device name like /dev/sdX1 or a directory. When specifying a device name the device is mounted automatically. When specifying a directory grml2usb is assuming that you did set up a bootloader on your own (or don’t need one) and a bootloader won’t be installed automatically.

The following options are supported:

--bootoptions=...
    Use specified bootoptions as default. To use flavour name as a argument for a boot parameter use %flavour which will be expanded to the flavour name. To add multiple bootoptions you can specify the option multiple time.

--bootloader-only
    Do not copy files but instead just install a bootloader. Note that the boot addons are copied to /boot/addons at this stage as well. If you want to skip copying the boot addons consider using the --skip-addons option.

--copy-only
    Copy files only but do not install a bootloader.

--dry-run
    Avoid executing commands, instead show what would be executed. Warning: please notice that the ISO has to be mounted anyway, otherwise identifying the Grml flavour would not be possible.

--format
    Format specified partition with FAT. Important: this will destroy any existing data on the specified partition!

--force
    Force any (possible dangerous) actions requiring manual interaction (like --format).

--grub
    Install grub bootloader instead of (default) syslinux.

--grub-mbr
    Install grub into MBR (Master Boot Record) instead of PBR (Partition Boot Record). Check out the mbr-vs-pbr section in the FAQ of this document for further details.

--help
    Display usage information and exit.

--mbr-menu
    Install master boot record (MBR) with integrated boot menu: interactively choose the partition to boot from, with a timeout to load the default partition, or boot from floppy. When NOT using the --mbr-menu option a MBR with LBA and large disc support but without an integrated boot menu is installed (so it’s not visible at all but instead directly jumps to the bootloader - being grub or syslinux). Note: This options is available only when using the default MBR and won’t have any effect if you’re using the --syslinux-mbr option.

--quiet
    Do not output anything but just errors on console.

--skip-addons
    Do not install /boot/addons/ files (like dos, grub, memdisk,...).

--remove-bootoption=...
    Remove specified bootoption (could be a regex) from existing boot options. Use multiple entries for removing different bootoptions at once.

--skip-bootflag
    Do not check for presence of boot flag on target device.

--skip-grub-config
    Skip generation of grub configuration files. By default the configuration files for syslinux and grub will be written so you’ve a working configuration file no matter whether you’re using grub or syslinux as bootloader.

--skip-mbr
    Do not touch/install the master boot record (MBR).

--skip-syslinux-config
    Skip generation of syslinux configuration files. By default the configuration files for syslinux and grub will be written so you’ve a working configuration file no matter whether you’re using grub or syslinux as bootloader.

--skip-usb-check
    Skip check to verify whether given device is a removable device. Some USB devices are known to report wrong information, when using such a device you can skip grml2usb’s removable device check.

--syslinux
    This option is deprecated and is being left only for backwards compatibility reasons. Syslinux is the default bootloader of grml2usb and therefore the --syslinux option doesn’t have any effects. If you do not want to use syslinux as bootloader consider using the --grub option.

--syslinux-mbr
    Install syslinux' master boot record (MBR, which is booting from the partition with the "active" flag set) instead of the default one. If you encounter any problems with the default MBR you can try using the syslinux MBR instead. If that works for you please let us know so we can adjust our default MBR accordingly.

-v, --version
    Return version and exit.

--verbose
    Enable verbose mode.

DEVELOPERS CORNER

  Directory layout on USB device

    boot/ ->
      |-- addons/
      |   |-- ...              [as provided on ISO]
      |-- release/
      |   |-- grml/
      |   |   |-- vmlinuz      [Kernel]
      |   |   |-- initrd.gz    [initramfs]
      |   |-- grml64
      |   |   |-- vmlinuz      [Kernel]
      |   |   |-- initrd.gz    [initramfs]
      |   |-- grml-small
      |   |   |-- vmlinuz
      |   |   |-- initrd.gz
      |   `-- grml64-small
      |       |-- vmlinuz
      |       |-- initrd.gz
      |-- grub/
      |   |-- grml.png         [graphical bootsplash background image for grub2]
      |   |-- grub.cfg         [configuration file for grub2]
      `-- syslinux/
          |-- grml.png         [graphical bootsplash background image for syslinux]
          |-- syslinux.cfg     [main configuration file for syslinux]
          `-- [....]           [several further config files for syslinux]

    grml/
      |-- grml2usb.txt         [not yet implemented]
      |-- grml-cheatcodes.txt  [list of bootoptions for Grml]
      |-- grml-version.txt     [file containing information about grml-version]
      |-- LICENSE.txt          [license information]
      |-- md5sums              [md5sums of original ISO]
      |-- README.txt           [informational text]
      `-- web/                 [browser related files]
          |-- index.html
          |-- style.css
          `-- images/
              |-- button.png
              |-- favicon.png
              |-- linux.jpg
              `-- logo.png

    live/
      |-- grml/
      |   |-- filesystem.module    [module specifying which squashfs should be used for grml]
      |   `-- grml.squashfs        [squashfs file for grml]
      |-- grml-small/
      |   |-- filesystem.module    [module specifying which squashfs should be used for grml-small]
      |   `-- grml-small.squashfs  [squashfs file for grml-small]
      `-- ...

  Grabbing the source

    % git clone https://github.com/grml/grml2usb.git

  Developers Debugging Hints

To play with grml2usb you can avoid using a real device via a loopback file setup, like:

    # dd if=/dev/zero of=~/loopback bs=1M count=100 # adjust size to your needs
    # losetup /dev/loop1 ~/loopback

Then create according partitions either running for example:

    # echo -en "n\np\n1\n\n\nt\n6\na\n1\n w\n" | fdisk /dev/loop1

or:

    # parted /dev/loop1 -s "mkpart primary fat32 0 -1s mkfs 1 fat32"

Finally create a filesystem and execute grml2usb as needed:

    # mkfs.vfat /dev/loop1
    # grml2usb --bootloader-only /grml/isos/grml-full-2025.08-amd64.iso /dev/loop1

  Performance tracing

    # blktrace -d /dev/sdX -o - | blkparse -i -
    # grml2usb grml-full-2025.08-amd64.iso /dev/sdX1

TROUBLESHOOTING AND PITFALLS WHEN BOOTING

Here is a list of common error messages from BIOS/bootloader when trying to boot from USB.
Error message | ran out of input data. System halted
Reason | Everything OK, except for the filesystem used on your USB device. So instead of fat16 you are using for example fat32. Fix: use the appropriate filesystem (fat16 for USB flash drive usually). The Bootsplash might be displayed, the kernel loads but you very soon get the error message.
Error message | Invalid operating system
Reason | the partition layout is not ok. Very probably there’s no primary partition (/dev/sdX{1..4}) or none has the flag bootable set.
Error message | Boot error.
Reason | Some BIOSses offer different modes for USB booting. The proper mode to boot a USB stick is USB-HDD. If that doesn’t work or is not supported by your system, you need to format your USB-Stick as USB-ZIP. To do this, syslinux contains an utility called mkdiskimage, which you can use to re-format your USB stick in USB-ZIP format running mkdiskimage -4 /dev/sdX 1 64 32. Please be aware that this procedure will erase all data on your stick. After executing mkdiskimage just continue installing as usual (grml2usb ... /dev/sdX4). Note that this is not going to work for any device larger than 8 GB, since mkdiskimage only supports 1024c 256h 63s. For a more detailed explanation, refer to /usr/share/doc/syslinux-common/usbkey.txt.
Error message | No operating system found.
Reason | you forgot to set the boot-flag on the partition. Or there really isn’t any operating system at all. :)
Error message | kernel-panic: unable to mount root-fs...
Reason | Kernel boots but fails to find the root filesystem. The root= argument in your kernel commandline is pointing to the wrong device. Adjust root=..., consider using root=UUID=....
Error message | Could not find kernel image: ...
Reason | either a broken isolinux/syslinux version or a broken BIOS. Check out whether the vendor provides a BIOS update or if using bootloader grub instead of isolinux/syslinux fixes the problem.

FREQUENTLY ASKED QUESTIONS (FAQ)

  Where can I get grml2usb?

grml2usb is available as Debian package via the grml-testing Debian repository[1].

If you do not want to (or can’t) use the grml2usb Debian package you can either use the grml2usb git tree running:

    git clone https://github.com/grml/grml2usb.git
    cd grml2usb
    make -C mbr
    sudo ./grml2usb ...

    Note

    It is NOT enough to have just the grml2usb script itself without the according files provided either via the Debian package or the git tree.

  Why can’t I just dd the ISO to a USB device?

Well, you can. :) Starting with Grml 2009.10 the ISOs are dd-able straight out-of-the-box.

    Important

    Note that ANY existing data on your USB device will be destroyed when using the dd approach.

This allows you to dd the Grml ISO to your USB device (use for example rawwrite[2] if you’ve just a Windows system available) running:

    % dd if=grml-full-2025.08-amd64.iso of=/dev/sdX

where /dev/sdX is your USB device. Of course this doesn’t provide such a flexible system like with grml2usb (no multi-ISO setup, no additional default bootoptions,...) but it’s a nice way to get a working USB boot setup if you don’t have grml2usb available.

  What’s the difference between grml2usb and just using dd?

grml2usb does not remove any data from your USB device and does not alter the partition table at all. grml2usb provides multi-ISO support, support for adding default bootoptions and selecting the bootloader (syslinux vs. grub) without having to manually touch the ISO at all.

  What’s grml2iso?

grml2iso is a script which uses grml2usb to generate a multiboot ISO out of several Grml ISOs. See man grml2iso for further details.

  grub-install complains about /sbin/grub-install and/or xfs_freeze?!

The following message:

    You shouldn't call /sbin/grub-install. Please call /usr/sbin/grub-install instead!
    xfs_freeze: specified file ["/tmp/tmpqaBK6z/boot/grub"] is not on an XFS filesystem

This is "normal". grub-install sends those messages to stderr. To avoid hiding any possible real error messages grml2usb doesn’t ignore those messages.

  grub-install complains about a unary operator?!

The following message:

    '/usr/sbin/grub-install: line 374: [: =: unary operator expected'

This is "normal". Just ignore it. (It usually doesn’t appear on the second invocation on the same device.)

  grub-install fails with grub-probe: error: unknown filesystem?!

The following message:

    grub-probe: error: unknown filesystem
    Auto-detection of a filesystem module failed.
    Please specify the module with the option `--modules' explicitly.

usually means that the device partition table says something else than the filesystem on the device. For example using FAT16 as filesystem type and using FAT32 as filesystem on the partition will not work. Either set filesystem type to FAT32 or format the partition using FAT16. It is essential that device partition table and filesystem use the same filesystem type.

  grub-setup fails after Attempting to install GRUB to a partition instead of the MBR?!

The following message:

    grub-setup: warn: Attempting to install GRUB to a partition instead of the MBR.  This is a BAD idea.
    grub-setup: warn: Embedding is not possible.  GRUB can only be installed in this setup by using blocklists.  However, blocklists are UNRELIABLE and its use is discouraged.
    grub-setup: error: Cannot read `/grub/core.img' correctly

appears when using grub2 versions older than 1.98 as those version introduced a regression which avoids that grub is being installed into a partition (PBR, Partition Boot Record) instead of MBR (Master Boot Record).

To work around this issue you can either 1) upgrade to grub versions >=1.98, 2) install grub into the MBR (Master Boot Record) using the --grub-mbr option of grml2usb or 3) switch to syslinux as bootmanager (just drop the --grub option).

  I’m getting something like Error: /usr/share/grml2usb/grub/splash.xpm.gz can not be read"!?"

Looks like you’ve only the grml2usb script itself available. Please make sure you’ve the grml2usb Debian package installed. The most resent stable version is available via the grml-testing Debian repository[1]. If you do not have a Debian system please see section Where can I get grml2usb? in this FAQ.

  Why do I have to use a FAT16/FAT32 filesystem?

Syslinux (currently) does not support any other filesystems besides FAT16/FAT32 (though that’s a sane default if you want to share your files with other (operating) systems). If you want to use a different filesystem (like ext2/3) use the bootloader grub instead using grml2usb’s --grub option.

  I think I’ve got a really cool idea!

Great! Please check out the TODO file[3]. Feel free to report your wishes to the author. Patches highly appreciated.

  I’ve problems with booting from USB.

Check out Troubleshooting and Pitfalls when booting.

  I’ve found a bug!

Please report it to the author. Please provide usage examples and output of your grml2usb commandline (consider using the "--verbose" option).

USAGE EXAMPLES

    # grml2usb /home/grml/grml-full-2025.08-amd64.iso /dev/sdX1

Install specified ISO on device /dev/sdX1.

    # grml2usb /home/grml/grml-full-2025.08-amd64.iso /home/grml/grml-full-2025.08-arm64.iso  /dev/sdX1

Install specified ISOs on device /dev/sdX1 for multibooting ISOs.

    # grml2usb /run/live/medium /dev/sdX1

Install currently running Grml live system on device /dev/sdX1.

    # grml2usb /run/live/medium /home/grml/grml-full-2025.08-amd64.iso /dev/sdX1

Install currently running Grml live system and the specified ISO on device /dev/sdX1 for multibooting.

    # grml2usb --format /home/grml/grml-full-2025.08-amd64.iso /dev/sdX1

Install specified ISO on device /dev/sdX1 and format partition /dev/sdX1 with FAT filesystem.

    # grml2usb --grub --grub-mbr /home/grml/grml-full-2025.08-amd64.iso /dev/sdX1

Install specified ISO on device /dev/sdX1 and use grub as bootloader (instead of syslinux being the default) and install a master boot record (MBR) to the MBR of /dev/sdX.

    # grml2usb --bootoptions="lang=de ssh=mysecret" grml-full-2025.08-amd64.iso /dev/sdX1
    # grml2usb --bootoptions="lang=de" --bootoptions="ssh=mysecret" grml-full-2025.08-amd64.iso /dev/sdX1

Install specified ISO on device /dev/sdX1 and use "lang=de ssh=mysecret" as default bootoptions.

    # grml2usb --remove-bootoption="vga=791" --remove-bootoption="nomce" grml-full-2025.08-amd64.iso /dev/sdX1

Install specified ISO on device /dev/sdX1 remove vga=791 and nomce from existing bootoptions.

    # grml2usb --bootoptions="persistent-path=%flavour_name" grml-full-2025.08-amd64.iso grml-full-2025.08-arm64.iso /dev/sdX1

Install specified ISOs on device /dev/sdx and add parameter persistent-path to every menu entry. %flavour_name will be expanded to the flavour of the specific iso, e.g. grml64 and grml.

ONLINE RESOURCES

Check out the grml2usb webpage[4], the grml2usb git repository[5] and the wiki for persistency[6].

BUGS

Please report feedback, bugreports and wishes to the author.

AUTHOR

Michael Prokop <mika@grml.org[7]>

NOTES

1.  the grml-testing Debian repository
    https://deb.grml.org/

2.  rawwrite
    http://www.chrysocome.net/rawwrite

3.  the TODO file
    https://github.com/grml/grml2usb/blob/master/TODO

4.  grml2usb webpage
    https://grml.org/grml2usb/

5.  grml2usb git repository
    https://github.com/grml/grml2usb

6.  persistency
    https://github.com/grml/grml/wiki/persistency

7.  mika@grml.org
    mailto:mika@grml.org